# coding: utf-8

"""
    NCBI Datasets API

    NCBI service to query and download biological sequence data across all domains of life from NCBI databases.  # noqa: E501

    The version of the OpenAPI document: v1alpha
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ncbi.datasets.configuration import Configuration


class DownloadSummaryError(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'code': 'str',
        'invalid_identifiers': 'list[str]',
        'message': 'str',
        'valid_identifiers': 'list[str]'
    }

    attribute_map = {
        'code': 'code',
        'invalid_identifiers': 'invalid_identifiers',
        'message': 'message',
        'valid_identifiers': 'valid_identifiers'
    }

    def __init__(self, code=None, invalid_identifiers=None, message=None, valid_identifiers=None, local_vars_configuration=None):  # noqa: E501
        """DownloadSummaryError - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._code = None
        self._invalid_identifiers = None
        self._message = None
        self._valid_identifiers = None
        self.discriminator = None

        if code is not None:
            self.code = code
        if invalid_identifiers is not None:
            self.invalid_identifiers = invalid_identifiers
        if message is not None:
            self.message = message
        if valid_identifiers is not None:
            self.valid_identifiers = valid_identifiers

    @property
    def code(self):
        """Gets the code of this DownloadSummaryError.  # noqa: E501


        :return: The code of this DownloadSummaryError.  # noqa: E501
        :rtype: str
        """
        return self._code

    @code.setter
    def code(self, code):
        """Sets the code of this DownloadSummaryError.


        :param code: The code of this DownloadSummaryError.  # noqa: E501
        :type: str
        """

        self._code = code

    @property
    def invalid_identifiers(self):
        """Gets the invalid_identifiers of this DownloadSummaryError.  # noqa: E501


        :return: The invalid_identifiers of this DownloadSummaryError.  # noqa: E501
        :rtype: list[str]
        """
        return self._invalid_identifiers

    @invalid_identifiers.setter
    def invalid_identifiers(self, invalid_identifiers):
        """Sets the invalid_identifiers of this DownloadSummaryError.


        :param invalid_identifiers: The invalid_identifiers of this DownloadSummaryError.  # noqa: E501
        :type: list[str]
        """

        self._invalid_identifiers = invalid_identifiers

    @property
    def message(self):
        """Gets the message of this DownloadSummaryError.  # noqa: E501


        :return: The message of this DownloadSummaryError.  # noqa: E501
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this DownloadSummaryError.


        :param message: The message of this DownloadSummaryError.  # noqa: E501
        :type: str
        """

        self._message = message

    @property
    def valid_identifiers(self):
        """Gets the valid_identifiers of this DownloadSummaryError.  # noqa: E501


        :return: The valid_identifiers of this DownloadSummaryError.  # noqa: E501
        :rtype: list[str]
        """
        return self._valid_identifiers

    @valid_identifiers.setter
    def valid_identifiers(self, valid_identifiers):
        """Sets the valid_identifiers of this DownloadSummaryError.


        :param valid_identifiers: The valid_identifiers of this DownloadSummaryError.  # noqa: E501
        :type: list[str]
        """

        self._valid_identifiers = valid_identifiers

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DownloadSummaryError):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DownloadSummaryError):
            return True

        return self.to_dict() != other.to_dict()
