# coding: utf-8

"""
    NCBI Datasets API

    NCBI service to query and download biological sequence data across all domains of life from NCBI databases.  # noqa: E501

    The version of the OpenAPI document: v1alpha
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ncbi.datasets.configuration import Configuration


class V1alpha1GeneDatasetRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'gene_ids': 'list[int]',
        'include_sequence_type': 'list[GeneDatasetRequestSeqType]'
    }

    attribute_map = {
        'gene_ids': 'gene_ids',
        'include_sequence_type': 'include_sequence_type'
    }

    def __init__(self, gene_ids=None, include_sequence_type=None, local_vars_configuration=None):  # noqa: E501
        """V1alpha1GeneDatasetRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._gene_ids = None
        self._include_sequence_type = None
        self.discriminator = None

        if gene_ids is not None:
            self.gene_ids = gene_ids
        if include_sequence_type is not None:
            self.include_sequence_type = include_sequence_type

    @property
    def gene_ids(self):
        """Gets the gene_ids of this V1alpha1GeneDatasetRequest.  # noqa: E501


        :return: The gene_ids of this V1alpha1GeneDatasetRequest.  # noqa: E501
        :rtype: list[int]
        """
        return self._gene_ids

    @gene_ids.setter
    def gene_ids(self, gene_ids):
        """Sets the gene_ids of this V1alpha1GeneDatasetRequest.


        :param gene_ids: The gene_ids of this V1alpha1GeneDatasetRequest.  # noqa: E501
        :type: list[int]
        """

        self._gene_ids = gene_ids

    @property
    def include_sequence_type(self):
        """Gets the include_sequence_type of this V1alpha1GeneDatasetRequest.  # noqa: E501


        :return: The include_sequence_type of this V1alpha1GeneDatasetRequest.  # noqa: E501
        :rtype: list[GeneDatasetRequestSeqType]
        """
        return self._include_sequence_type

    @include_sequence_type.setter
    def include_sequence_type(self, include_sequence_type):
        """Sets the include_sequence_type of this V1alpha1GeneDatasetRequest.


        :param include_sequence_type: The include_sequence_type of this V1alpha1GeneDatasetRequest.  # noqa: E501
        :type: list[GeneDatasetRequestSeqType]
        """

        self._include_sequence_type = include_sequence_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, V1alpha1GeneDatasetRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, V1alpha1GeneDatasetRequest):
            return True

        return self.to_dict() != other.to_dict()
